
(function () {
    var ua = navigator.userAgent,
        iStuff = ua.match(/iPhone/i) || ua.match(/iPad/i),
        typeOfCanvas = typeof HTMLCanvasElement,
        nativeCanvasSupport = (typeOfCanvas == 'object' || typeOfCanvas == 'function'),
        textSupport = nativeCanvasSupport
            && (typeof document.createElement('canvas').getContext('2d').fillText == 'function');
    //I'm setting this based on the fact that ExCanvas provides text support for IE
    //and that as of today iPhone/iPad current text support is lame
    labelType = (!nativeCanvasSupport || (textSupport && !iStuff)) ? 'Native' : 'HTML';
    nativeTextSupport = labelType == 'Native';
    useGradients = nativeCanvasSupport;
    animate = !(iStuff || !nativeCanvasSupport);
})();


var SMALL_BROWSER = false;
var BLTCON0_VALUE = 0;
var BLTCON1_VALUE = 0;

function elm(_id) {
    return document.getElementById(_id);
}

function setVal(_id, _val) {
    document.getElementById(_id).value = _val;
}

function sndy_modal(_title, data) {
    let html = "";
    if (data.content) {
        html += data.content;
        html += "</br>";
    }
    if (data.bulletPoints) {
        html += "<ul>";
        for (let i = 0; i < data.bulletPoints.length; i++) {
            html += "<li>" + data.bulletPoints[i] + "</li>";
        }
        html += "</ul>";
    }
    if (data.more) {
        html += "</br><a href=" + data.more + ">learn more</a>";
    }
    elm("exampleModalLongTitle").innerHTML = _title;
    elm("modalbody").innerHTML = html;

    $('#exampleModalCenter').modal('show');
}


function init() {

    let ow = window.innerWidth;
    let oh = window.innerHeight;
    let ratio = ow / oh;
    let h = window.innerHeight * 0.8;
    let w = window.innerWidth * 0.8;

    if ((w < 350) || (w < h * 1.2)) {
        SMALL_BROWSER = true;
    }

    renderD();
}

function renderRect(_data) {
    for (var x = 0; x < 64; x++) {
        _data[x * 4 + 0] = 0;
        _data[x * 4 + 1] = 0;
        _data[x * 4 + 2] = 0;
        _data[x * 4 + 3] = 255;

        _data[64 * 4 * 63 + x * 4 + 0] = 0;
        _data[63 * 4 * 63 + x * 4 + 1] = 0;
        _data[63 * 4 * 63 + x * 4 + 2] = 0;
        _data[63 * 4 * 63 + x * 4 + 3] = 255;

        _data[x * 64 * 4 + 0] = 0;
        _data[x * 64 * 4 + 1] = 0;
        _data[x * 64 * 4 + 2] = 0;
        _data[x * 64 * 4 + 3] = 255;

        _data[x * 64 * 4 + 63 * 4 + 0] = 0;
        _data[x * 64 * 4 + 63 * 4 +  1] = 0;
        _data[x * 64 * 4 + 63 * 4 +  2] = 0;
        _data[x * 64 * 4 + 63 * 4 +  3] = 255;
    }
}

function renderA() {
    var canvas = elm("ACvs");
    var context = canvas.getContext("2d");

    var width = 64;
    var height = 64;
    var imageData = context.createImageData(width, height);
    if (elm('useSourceA').checked) {
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                let col = 255;
                //     if ((x & 7) === 0) col = 0;
                let maxDistToCenter = y / 2;
                let curX = Math.abs(x - width / 2);
                if (curX < maxDistToCenter) col = 0;
                if (col === 0) {
                    imageData.data[ofs++] = 0;
                    imageData.data[ofs++] = 180;
                    imageData.data[ofs++] = 0;
                } else {
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                }
                imageData.data[ofs++] = 255;
            }
        }
        renderRect(imageData.data);
        context.putImageData(imageData, 0, 0);
    } else {
        context.fillStyle = "#000000";
        context.fillRect(0, 0, 64, 64);
        context.fillStyle = "#FFFFFF";
        context.fillRect(1, 1, 62, 62);
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 255;
            }
        }
        context.putImageData(imageData, 0, 0);
        context.fillStyle = "#000000";
        context.fillText(" DMA OFF", 0,32);
    }
}

function renderB() {
    var canvas = elm("BCvs");
    var context = canvas.getContext("2d");

    var width = 64;
    var height = 64;
    var imageData = context.createImageData(width, height);
    if (elm('useSourceB').checked) {
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                let col = 255;
                let d = Math.sqrt((x - 32) * (x - 32) + (y - 32) * (y - 32));
                if (d < 25) col = 0;
                if (col === 0) {
                    imageData.data[ofs++] = 0;
                    imageData.data[ofs++] = 180;
                    imageData.data[ofs++] = 0;
                } else {
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                }
                imageData.data[ofs++] = 255;
            }
        }
        renderRect(imageData.data);
        context.putImageData(imageData, 0, 0);
    } else {
        context.fillStyle = "#000000";
        context.fillRect(0, 0, 64, 64);
        context.fillStyle = "#FFFFFF";
        context.fillRect(1, 1, 62, 62);
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 255;
            }
        }
        context.putImageData(imageData, 0, 0);
        context.fillStyle = "#000000";
        context.fillText(" DMA OFF", 0,32);
    }
}

function renderC() {
    var canvas = elm("CCvs");
    var context = canvas.getContext("2d");

    var width = 64;
    var height = 64;
    var imageData = context.createImageData(width, height);
    if (elm('useSourceC').checked) {
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                let col = 255;
                if ((y & 7) === 0) col = 0;
                if (col === 0) {
                    imageData.data[ofs++] = 0;
                    imageData.data[ofs++] = 180;
                    imageData.data[ofs++] = 0;
                } else {
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                }
                imageData.data[ofs++] = 255;
            }
        }
        renderRect(imageData.data);
        context.putImageData(imageData, 0, 0);
    } else {
        context.fillStyle = "#000000";
        context.fillRect(0, 0, 64, 64);
        context.fillStyle = "#FFFFFF";
        context.fillRect(1, 1, 62, 62);
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 255;
            }
        }
        context.putImageData(imageData, 0, 0);
        context.fillStyle = "#000000";
        context.fillText(" DMA OFF", 0,32);
    }
}


function renderD() {
    renderA();
    renderB();
    renderC();
    var canvas = elm("DCvs");
    var context = canvas.getContext("2d");

    var width = 64;
    var height = 64;

    var ACVS = elm("ACvs");
    var BCVS = elm("BCvs");
    var CCVS = elm("CCvs");
    var ACTX = ACVS.getContext("2d");
    var BCTX = BCVS.getContext("2d");
    var CCTX = CCVS.getContext("2d");

    var ADATA = ACTX.getImageData(0, 0, width, height).data;
    var BDATA = BCTX.getImageData(0, 0, width, height).data;
    var CDATA = CCTX.getImageData(0, 0, width, height).data;
    let MINTERM = BLTCON0_VALUE & 255;
    let ASHIFT = getASHIFT();
    let BSHIFT = getBSHIFT();

    let useA = false;
    let useB = false;
    let useC = false;
    if (elm('useSourceC').checked) useC = true;
    if (elm('useSourceB').checked) useB = true;
    if (elm('useSourceA').checked) useA = true;

    var width = 64;
    var height = 64;
    var imageData = context.createImageData(width, height);
    if (elm('useDestD').checked) {
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                let lit = false;
                let aOfs = Math.max(0, ofs - 4 * ASHIFT);
                let bOfs = Math.max(0, ofs - 4 * BSHIFT);
                let A = ADATA[aOfs] === 0;
                let B = BDATA[bOfs] === 0;
                let C = CDATA[ofs] === 0;
                if (!useA) A = Math.random() > 0.5;
                if (!useB) B = Math.random() > 0.5;
                if (!useC) C = Math.random() > 0.5;

                if (MINTERM & 1) {
                    if (!A && !B && !C) lit = true;
                }
                if (MINTERM & 2) {
                    if (!A && !B && C) lit = true;
                }
                if (MINTERM & 4) {
                    if (!A && B && !C) lit = true;
                }
                if (MINTERM & 8) {
                    if (!A && B && C) lit = true;
                }
                if (MINTERM & 16) {
                    if (A && !B && !C) lit = true;
                }
                if (MINTERM & 32) {
                    if (A && !B && C) lit = true;
                }
                if (MINTERM & 64) {
                    if (A && B && !C) lit = true;
                }
                if (MINTERM & 128) {
                    if (A && B && C) lit = true;
                }

                if (lit) {
                    imageData.data[ofs++] = 0;
                    imageData.data[ofs++] = 180;
                    imageData.data[ofs++] = 0;

                } else {
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                    imageData.data[ofs++] = 255;
                }
                renderRect(imageData.data);
                imageData.data[ofs++] = 255;
            }
        }
        context.putImageData(imageData, 0, 0);
    } else {
        context.fillStyle = "#000000";
        context.fillRect(0, 0, 64, 64);
        context.fillStyle = "#FFFFFF";
        context.fillRect(1, 1, 62, 62);
        let ofs = 0;
        for (var y = 0; y < height; y++) {
            for (var x = 0; x < width; x++) {
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 200 + Math.floor(55 * Math.random());
                imageData.data[ofs++] = 255;
            }
        }
        context.putImageData(imageData, 0, 0);
        context.fillStyle = "#000000";
        context.fillText(" DMA OFF", 0,32);
    }
}

function getASHIFT() {
    let ASHIFT = parseInt(elm('ASHIFT').value);
    if (!ASHIFT || ASHIFT < 0) ASHIFT = 0;
    if (ASHIFT > 15) ASHIFT = 15;
    setVal('ASHIFT', ASHIFT);
    return ASHIFT;
}

function getBSHIFT() {
    let BSHIFT = parseInt(elm('BSHIFT').value);
    if (!BSHIFT || BSHIFT < 0) BSHIFT = 0;
    if (BSHIFT > 15) BSHIFT = 15;
    setVal('BSHIFT', BSHIFT);
    return BSHIFT;
}

function minOn(_m) {
    if (_m == 1) return true;
    if (_m == 2) return true;
    return false;
}

function minOff(_m) {
    if (_m == 0) return true;
    if (_m == 2) return true;
    return false;
}

function hasBit(_v, _index) {
    let msk = 1 << _index;
    if ((_v & msk) !== 0) return true;
    else return false;
}

function refreshBLTCON1() {
    let BSHIFT = getBSHIFT();
    BLTCON1_VALUE = BSHIFT << 12;
    if (elm('EFE').checked) BLTCON1_VALUE |= 16;
    if (elm('IFE').checked) BLTCON1_VALUE |= 8;
    if (elm('DESC').checked) BLTCON1_VALUE |= 2;
    setVal('BLTCON1', '$' + BLTCON1_VALUE.toString(16));
}

function recomputeBLTCON0() {
    BLTCON0_VALUE = 0;
    let ASHIFT = getASHIFT();
    let BSHIFT = getBSHIFT();
    BLTCON0_VALUE |= ASHIFT << 12;


    if (elm('useDestD').checked) BLTCON0_VALUE |= 256;
    if (elm('useSourceC').checked) BLTCON0_VALUE |= 512;
    if (elm('useSourceB').checked) BLTCON0_VALUE |= 1024;
    if (elm('useSourceA').checked) BLTCON0_VALUE |= 2048;

    let MINTERM = 0;
    if (elm('MINTERM0').checked) MINTERM |= 1;
    if (elm('MINTERM1').checked) MINTERM |= 2;
    if (elm('MINTERM2').checked) MINTERM |= 4;
    if (elm('MINTERM3').checked) MINTERM |= 8;
    if (elm('MINTERM4').checked) MINTERM |= 16;
    if (elm('MINTERM5').checked) MINTERM |= 32;
    if (elm('MINTERM6').checked) MINTERM |= 64;
    if (elm('MINTERM7').checked) MINTERM |= 128;

    BLTCON0_VALUE |= MINTERM;

    setVal('BLTCON0', '$' + BLTCON0_VALUE.toString(16));
    refreshBLTCON1();
    renderD();
}

function updateBLTCON0Checkboxes(_value, _vb) {
    if (_value & 256) elm('useDestD').checked = true; else elm('useDestD').checked = false;
    if (_value & 512) elm('useSourceC').checked = true; else elm('useSourceC').checked = false;
    if (_value & 1024) elm('useSourceB').checked = true; else elm('useSourceB').checked = false;
    if (_value & 2048) elm('useSourceA').checked = true; else elm('useSourceA').checked = false;

    let ASHIFT = 0;
    if (_value & 4096) ASHIFT |= 1;
    if (_value & 8192) ASHIFT |= 2;
    if (_value & 16384) ASHIFT |= 4;
    if (_value & 32768) ASHIFT |= 8;
    setVal('ASHIFT', ASHIFT);

    let BSHIFT = 0;
    if (_vb & 4096) BSHIFT |= 1;
    if (_vb & 8192) BSHIFT |= 2;
    if (_vb & 16384) BSHIFT |= 4;
    if (_vb & 32768) BSHIFT |= 8;
    setVal('BSHIFT', BSHIFT);
    if (_vb & 2) elm('DESC').checked = true; else elm('DESC').checked = false;
    if (_vb & 8) elm('IFE').checked = true; else elm('IFE').checked = false;
    if (_vb & 16) elm('EFE').checked = true; else elm('EFE').checked = false;

    let MINTERM = _value & 255;
    if (hasBit(MINTERM, 0)) elm('MINTERM0').checked = true; else elm('MINTERM0').checked = false;
    if (hasBit(MINTERM, 1)) elm('MINTERM1').checked = true; else elm('MINTERM1').checked = false;
    if (hasBit(MINTERM, 2)) elm('MINTERM2').checked = true; else elm('MINTERM2').checked = false;
    if (hasBit(MINTERM, 3)) elm('MINTERM3').checked = true; else elm('MINTERM3').checked = false;
    if (hasBit(MINTERM, 4)) elm('MINTERM4').checked = true; else elm('MINTERM4').checked = false;
    if (hasBit(MINTERM, 5)) elm('MINTERM5').checked = true; else elm('MINTERM5').checked = false;
    if (hasBit(MINTERM, 6)) elm('MINTERM6').checked = true; else elm('MINTERM6').checked = false;
    if (hasBit(MINTERM, 7)) elm('MINTERM7').checked = true; else elm('MINTERM7').checked = false;

    renderD();
}

function onBLTCON0Mode(_mode) {
    switch (_mode) {
        case 'BLTCON0_custom': break;
        case 'BLTCON0_clear': BLTCON0_VALUE = 0x100; BLTCON1_VALUE = 0; break;
        case 'BLTCON0_fill': BLTCON0_VALUE = 0x9f0; BLTCON1_VALUE = 0x12; break;
        case 'BLTCON0_copy': BLTCON0_VALUE = 0x9f0; BLTCON1_VALUE = 0; break;
        case 'BLTCON0_mask': BLTCON0_VALUE = 0xdc0; BLTCON1_VALUE = 0; break;
        case 'BLTCON0_bob': BLTCON0_VALUE = 0xfea; BLTCON1_VALUE = 0; break;
    }
    setVal('BLTCON0', '$' + BLTCON0_VALUE.toString(16));
    updateBLTCON0Checkboxes(BLTCON0_VALUE, BLTCON1_VALUE);
    refreshBLTCON1();
}

function onCustomBTLCON0() {
    let v = elm('BLTCON0').value;
    if (v[0] == '$') v = v.substring(1);
    BLTCON0_VALUE = parseInt(v, 16);
    setVal('BLTCON0', '$' + BLTCON0_VALUE.toString(16));

    v = elm('BLTCON1').value;
    if (v[0] == '$') v = v.substring(1);
    BLTCON1_VALUE = parseInt(v, 16);
    setVal('BLTCON1', '$' + BLTCON1_VALUE.toString(16));

    updateBLTCON0Checkboxes(BLTCON0_VALUE, BLTCON1_VALUE);
}